(******************************************************************************
 * ACButton                                                                   *
 ******************************************************************************)
unit ACButton;

(******************************************************************************
 * Interface                                                                  *
 ******************************************************************************)
 interface

(******************************************************************************
 * Uses                                                                       *
 ******************************************************************************)
 uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;



(******************************************************************************
 * Type                                                                       *
 ******************************************************************************)
 type
  TACButton = class(TCustomPanel)
  private
    { Private declarations }
    Mouse_Captured : Boolean;
    Bmp1,
    Bmp2,
    Bmp3,
    Bmp4  : TBitMap;
    Is_Mouse_Down : Boolean; (* Indica se il bottone del mouse  premuto *)
    xPos, yPos : Integer;  (* Indicano la posizione del mouse *)

  protected
    { Protected declarations }
    function mouse_dentro(x,y:Integer):Boolean;
    procedure paint;override;
    procedure mouse_move(var Msg: TMessage); Message wm_mousemove;
    procedure mouse_down(var Msg: TMessage); Message WM_LBUTTONDOWN;
    procedure mouse_up(var Msg: TMessage); Message WM_LBUTTONUP ;
    procedure old_paint;
    procedure disegna_bitmap(x:Integer);
    procedure KeyAccel(var Message: TCMDialogChar); message CM_DIALOGCHAR;

  public
    { Public declarations }
    constructor Create(AOwner: TComponent);override;
    destructor Destroy; override;
  published
    { Published declarations }
    property Caption;
    property OnClick;

  end;

(******************************************************************************
 * Implementation                                                             *
 ******************************************************************************)
implementation

(*$r AcButtonResource.Res *)

(******************************************************************************
 * Paint                                                                      *
 ******************************************************************************)
procedure TAcButton.paint;
Const diff = 1;
//Var
//  Aggiunta : Integer;
Begin
//;inherited;
  old_paint;
  if(Mouse_Captured) then
  begin
//    if(is_mouse_down) then aggiunta := 1
//    else aggiunta := 0;
    Canvas.Pen.Color := clBlack;
    Canvas.Pen.Color := clGray;
    Canvas.Pen.Width := 2;
    Canvas.RoundRect(0,0,width,height,height,height);
    Canvas.Pen.Width := 1;
    Canvas.Pen.Color := clSilver;
//    Canvas.RoundRect(0,0,width,height,height,height);
    Canvas.RoundRect(0+DIFF,0+DIFF,width-DIFF,height-DIFF,height-DIFF,height-DIFF);
    canvas.brush.color := Color;
    if(is_Mouse_down) then
    begin
      if (mouse_dentro(xPos,Ypos)) then disegna_bitmap(3)
      Else disegna_bitmap(1);
    end
    else disegna_bitmap(2);
  end
  Else
  Begin
    Canvas.Pen.Color := clSilver;
    Canvas.Pen.Width := 1;
    Canvas.RoundRect(0,0,width,height,height,height);
    canvas.brush.color := Color;
    disegna_bitmap(1);

  End;
End;


(******************************************************************************
 * Mouse Move                                                                 *
 ******************************************************************************)
procedure TACButton.mouse_Move(var Msg: TMessage);
begin
  xPos := LOWORD(msg.lParam);
  yPos := HIWORD(msg.lParam);

  if(not Mouse_Captured) then
  begin
    Mouse_Captured := True;
    SetCapture(Handle);
    Invalidate;
  end
  else
  begin
    if not(mouse_dentro(xPos,yPos)) then
    begin

      if (not Is_Mouse_Down) then
      begin
        ReleaseCapture;
        Mouse_Captured := False;
        Invalidate;
      End;

    end;
  end;
  inherited;
end;

(******************************************************************************
 * Constructor                                                                *
 ******************************************************************************)
constructor TACButton.Create(AOwner: TComponent);
begin
  inherited;
  Mouse_Captured := False;
  BevelInner := bvNone;
  BevelOuter := bvNone;
  Color := clInfoBk;
  Bmp1 := TBitMap.Create;
  Bmp2 := TBitMap.Create;
  Bmp3 := TBitMap.Create;
  Bmp4 := TBitMap.Create;
  Bmp1.LoadFromResourceName(hInstance,'TACButton1');
  Bmp2.LoadFromResourceName(hInstance,'TACButton2');
  Bmp3.LoadFromResourceName(hInstance,'TACButton3');
  Is_Mouse_Down := False;
  Alignment := taCenter;

end;

(******************************************************************************
 * Mouse Down                                                                 *
 ******************************************************************************)
procedure TACButton.mouse_down(var Msg: TMessage); //Message wm_mouseDown;
begin
  inherited;
  Is_Mouse_Down := True;
  Invalidate;
end;


(******************************************************************************
 * Mouse Up                                                                   *
 ******************************************************************************)
procedure TACButton.mouse_up(var Msg: TMessage); //Message wm_mouseDown;
begin
  inherited;
  Mouse_Captured := False;
  Is_Mouse_Down := False;
  Invalidate;
end;

(******************************************************************************
 * Destructor                                                                 *
 ******************************************************************************)
destructor TACButton.Destroy;
begin
 Bmp1.Free;
 Bmp2.Free;
 Bmp3.Free;
 Bmp4.Free;
 Inherited;
end;

(******************************************************************************
 * Old_Paint                                                                  *
 ******************************************************************************)
procedure TACButton.old_paint;
var
  Rect: TRect;
  TopColor, BottomColor: TColor;
  FontHeight: Integer;
  Aggiunta : Integer;
const
  Alignments: array[TAlignment] of Word = (DT_LEFT, DT_RIGHT, DT_CENTER);

  procedure AdjustColors(Bevel: TPanelBevel);
  begin
    TopColor := clBtnHighlight;
    if Bevel = bvLowered then TopColor := clBtnShadow;
    BottomColor := clBtnShadow;
    if Bevel = bvLowered then BottomColor := clBtnHighlight;
  end;

begin
  if(is_mouse_down) then aggiunta := 1
  else aggiunta := 0;

  Rect := GetClientRect;
  if BevelOuter <> bvNone then
  begin
    AdjustColors(BevelOuter);
    Frame3D(Canvas, Rect, TopColor, BottomColor, BevelWidth);
  end;
  Frame3D(Canvas, Rect, Color, Color, BorderWidth);
  if BevelInner <> bvNone then
  begin
    AdjustColors(BevelInner);
    Frame3D(Canvas, Rect, TopColor, BottomColor, BevelWidth);
  end;
  with Canvas do
  begin
    Brush.Color := Color;
    FillRect(Rect);
    Brush.Style := bsClear;
    Font := Self.Font;
    FontHeight := TextHeight('W');
    with Rect do
    begin
      Top := ((Bottom + Top) - FontHeight) div 2;
      Bottom := Top + FontHeight;
//      Left := 0;
    end;
    Rect.Top := Rect.Top + Aggiunta;
    Rect.Bottom := Rect.Bottom + Aggiunta;
    DrawText(Handle, PChar(Caption), -1, Rect, (DT_EXPANDTABS or
      DT_VCENTER) or Alignments[Alignment]);
  end;
End;

(******************************************************************************
 * mouse_dentro                                                               *
 ******************************************************************************)
function TACButton.mouse_dentro(x,y:Integer):Boolean;
begin
 mouse_dentro := not((x<0)or(y<0)or(x>width)or(y>height));
end;

(******************************************************************************
 * disegna_bitmap                                                             *
 ******************************************************************************)
procedure TACButton.disegna_bitmap(x:Integer);
var
 Aggiunta : Integer;
 Larg,               // Altezza immagine
 Altz   : Integer;   // Larghezza Immagine

begin
  if(is_mouse_down) then aggiunta := 1
  else aggiunta := 0;
  Altz := Bmp1.Canvas.ClipRect.Bottom-Bmp1.Canvas.ClipRect.top;
  Larg := Bmp1.Canvas.ClipRect.Right-Bmp1.Canvas.ClipRect.Left;

 case x of
 1:
  canvas.BrushCopy(Rect(5,aggiunta+(Height-Altz)div 2,5+Larg,aggiunta+Altz+(Height-Altz)div 2),
                   Bmp1,
                   Bmp1.Canvas.ClipRect,
                   Bmp1.Canvas.pixels[0,0]);

 2:
  canvas.BrushCopy(Rect(5,aggiunta+(Height-Altz)div 2,5+Larg,aggiunta+Altz+(Height-Altz)div 2),
                   Bmp2,
                   Bmp2.Canvas.ClipRect,
                   Bmp2.Canvas.pixels[0,0]);

 3:
  canvas.BrushCopy(Rect(5,aggiunta+(Height-Altz)div 2,5+Larg,aggiunta+Altz+(Height-Altz)div 2),
                   Bmp3,
                   Bmp3.Canvas.ClipRect,
                   Bmp3.Canvas.pixels[0,0]);

 end;

end;

(******************************************************************************
 * KeyAccel                                                                   *
 ******************************************************************************)
procedure TACButton.KeyAccel(var Message: TCMDialogChar);
begin
  with Message do
  begin
    if IsAccel(CharCode, Caption) and Enabled then
    begin
      Click;
      Result := 1;
    end
    else inherited;
  end;
end;

end.
