(******************************************************************************
 * ACTransparentImage                                                         *
 ******************************************************************************)
unit ACTransparentImage;

(******************************************************************************
 * Interface                                                                  *
 ******************************************************************************)
 interface

(******************************************************************************
 * Uses                                                                       *
 ******************************************************************************)
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls;

(******************************************************************************
 * TACTransparentImage                                                        *
 ******************************************************************************)
type
  TACTransparentImage = class(TGraphicControl)
  private
    { Private declarations }
    FColore : TColor;
    Ftras   : boolean;
    FBMP    : TBitMap;
  protected
    { Protected declarations }
    procedure SetBitMap(V : TBitMap);

    procedure Set_FColore(C:TColor);
    procedure Set_F_Tras(V:Boolean);
  public
    { Public declarations }

    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure paint;Override;
  published
    { Published declarations }
    property TransparentColor : TColor Read Fcolore Write Set_FColore;
    Property Transparent : Boolean read Ftras Write Set_F_TRas;
    Property BitMap : TBitMap Read FBmp Write SetBitMap;
  end;

(******************************************************************************
 * Implementation                                                             *
 ******************************************************************************)
implementation


(******************************************************************************
 * paint                                                                      *
 ******************************************************************************)
procedure TACTransparentImage.paint;
Var
  Rect1 : TRect;
//  c1,c2 : Integer;
  Bmp : TBitMap;
Begin
//   inherited;
   if(Bitmap.height=0) then
   begin
     exit;
   end;
   Height := Bitmap.height;
   Width := Bitmap.Width;

   Rect1 := Rect(0,0,Width,Height);
   Bmp := TBitMap.Create;
   Bmp.Width := Width;
   Bmp.Height := Height;
   Bmp.Canvas.CopyRect(Rect1,Canvas,Rect1);
   LockWindowUpdate(bmp.canvas.Handle);
   if (Transparent) then
   begin
     bmp.canvas.brush.color := Color;
     bmp.canvas.BrushCopy(rect1,bitmap,rect1,TransparentColor);
   End
   Else
   Begin
      bmp.Canvas.CopyRect(Rect1,bitmap.Canvas,Rect1);
   End;
   Canvas.CopyRect(Rect1,Bmp.Canvas,Rect1);
   LockWindowUpdate(0);
   Bmp.Free;

End;

(******************************************************************************
 * Create                                                                     *
 ******************************************************************************)
constructor TACTransparentImage.Create(AOwner: TComponent);
Begin
  Inherited;
  Height := 40;
  Width := 40;
  FBMP := TBitMap.Create;
End;

(******************************************************************************
 * Destroy                                                                    *
 ******************************************************************************)
destructor TACTransparentImage.Destroy;
Begin
  FBMP.Free;
  Inherited;
End;

(******************************************************************************
 * SetBitMap                                                                  *
 ******************************************************************************)
procedure TACTransparentImage.SetBitMap(V : TBitMap);
begin
   FBMP.Assign(V);
   Height := v.height;
   Width := v.Width;
   Invalidate;
end;

(******************************************************************************
 * Set_FColore                                                                *
 ******************************************************************************)
procedure TACTransparentImage.Set_FColore(C:TColor);
Begin
  FColore := C;
  invalidate;
End;

(******************************************************************************
 * Set_F_Tras(V:Boolean);                                                     *
 ******************************************************************************)
procedure TACTransparentImage.Set_F_Tras(V:Boolean);
Begin
  FTras := V;
  invalidate;
End;

end.
