(******************************************************************************
 * AcHyperLink                                                                *
 ******************************************************************************)
unit AcHyperLink;

(******************************************************************************
 * Interface                                                                  *
 ******************************************************************************)
interface

(******************************************************************************
 * Uses                                                                       *
 ******************************************************************************)
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ACTransparentImage;

(******************************************************************************
 * Type                                                                       *
 ******************************************************************************)
type
  PACLabelList = ^TACLabelList;
  TACLabelList = Record
     Lbl   : TLabel;
     Link  : String; // File name
     Next  : PACLabelList;
  End;
  PACImageList = ^TACImageList;
  TACImageList = Record
     Img   : TACTransparentImage;
     Next  : PACImageList;
  End;

  TACHyperLink = class(TScrollBox)
  private
    { Private declarations }
    FNomeFile : String;
    FPageNum  : Integer;
  protected
    { Protected declarations }
    FontName  : String;
    FontSize  : Integer;
    ElencoLbl : PACLabelList;
    ElencoImg : PACImageList;
    FontBold,
    FontItalic,
    FontUnderline,
    FontStrikeOut : Boolean;
    FontColore    : Integer;
    PaginaDaCaricare : Integer;
    Procedure Add_Label(L:TLabel;Link:String);
    Procedure Add_Image(I:TACTransparentImage);
    Procedure on_Click (Sender: TObject);// of object;
    procedure WMPaint(var Message: TWMPaint); message wm_Paint;
    Procedure Remove_Label;
    Procedure Remove_Image;
    Procedure ReadPage(Num:Integer);
    procedure insert_lbl(x,y,Pagina:Integer;Testo,Link:String);
  public
    { Public declarations }
    Constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    { Published declarations }
    Property FileName : String Read FNomeFile Write FNomeFile;
    Property PageNumber : Integer Read FPageNum write ReadPage;
  end;

(******************************************************************************
 * Implementation                                                             *
 ******************************************************************************)
implementation

(******************************************************************************
 * Uses                                                                       *
 ******************************************************************************)
uses
  IniFiles;

(******************************************************************************
 * insert_lbl                                                                 *
 ******************************************************************************)
procedure TACHyperLink.insert_lbl(x,y,Pagina:Integer;Testo,Link:String);
Var
    Lbl         : TLabel;
Begin
   Lbl := TLabel.Create(Self);
   Lbl.Font.Style := [];
   if(FontBold) then Lbl.Font.Style := [fsBold];
   if(FontItalic) then Lbl.Font.Style := Lbl.Font.Style + [fsItalic];
   if(FontUnderLine) then Lbl.Font.Style := Lbl.Font.Style + [fsUnderLine];
   if(FontStrikeOut) then Lbl.Font.Style := Lbl.Font.Style + [fsStrikeOut];
   Lbl.Left := x;
   Lbl.Top := y;
   Lbl.Font.Name := FontName;
   Lbl.Font.Size := FontSize;
   Lbl.Caption := Testo;
   Lbl.Font.Color := FontColore;
   Lbl.Parent := Self;
   Lbl.AutoSize := True;
   Lbl.Tag := Pagina;
   Lbl.Visible := True;
   Lbl.OnClick := on_Click;
   Add_Label(Lbl,Link);
End;
(******************************************************************************
 * ReadPage                                                                   *
 ******************************************************************************)
Procedure TACHyperLink.ReadPage(Num:Integer);
Var Ini : TIniFile;
    conta1 : Integer;
    Testo1,
    Testo2 : String;
    app1,app2,app3,app4, Pagina : Integer;
    pos_x,pos_y : Integer;
    Img         : TACTransparentImage;
    Nome        : String;
    Percorso    : String;
    AppNome     : String;
Begin
  Percorso:=ExtractFilePath(FileName);
  if (Percorso[Length(Percorso)]<>'\') then Percorso := Percorso + '\';
  FPageNum := Num;
  if(PageNumber<=0) then exit;
  Ini := TIniFile.Create(FileName);
  Remove_Label;
  Remove_Image;
  Conta1 := 0;
  Pagina := 0;
  With Ini do
  begin
    Testo1 := ReadString('Page'+IntToStr(Num),'P'+IntToStr(Conta1),'');
    While (testo1<>'') do
    Begin
      Testo2 := UpperCase(Testo1);
//********** Font Name
      if (Pos('FONTNAME',Testo2)=1) then
      begin
        FontName := Copy(Testo1,Pos('=',Testo1)+1,Length(Testo1)-Pos('=',Testo1)+1);
      End;
//********** Font Size
      if (Pos('FONTSIZE',Testo2)=1) then
      begin
        FontSize := StrToInt(Copy(Testo1,Pos('=',Testo1)+1,Length(Testo1)-Pos('=',Testo1)+1));
      End;
//********** Link
      if (Pos('LINK',Testo2)=1) then
      begin
        app1 := Pos('[',Testo2);
        app2 := Pos(',',Testo2);
        app3 := Pos('*',Testo2);
        app4 := Pos(']',Testo2);
        Pos_x := StrToInt(Copy(Testo1,app1+1,app2-1-app1));
        Pos_y := StrToInt(Copy(Testo1,app2+1,app3-1-app2));
        Pagina := StrToInt(Copy(Testo1,app3+1,app4-1-app3));
        insert_lbl(Pos_x,Pos_y,Pagina,Copy(Testo1,app4+1,Length(Testo1)-app4),'');
      End;
//********** Text
      if (Pos('TEXT',Testo2)=1) then
      begin
        app1 := Pos('[',Testo2);
        app2 := Pos(',',Testo2);
        app3 := Pos(']',Testo2);
        Pos_x := StrToInt(Copy(Testo1,app1+1,app2-1-app1));
        Pos_y := StrToInt(Copy(Testo1,app2+1,app3-1-app2));
        insert_lbl(Pos_x,Pos_y,Pagina,Copy(Testo1,app3+1,Length(Testo1)-app3),'');
      End;
//********** Image
      if (Pos('IMAGE',Testo2)=1) then
      begin
        app1 := Pos('[',Testo2);
        app2 := Pos(',',Testo2);
        app3 := Pos(']',Testo2);
        Pos_x := StrToInt(Copy(Testo1,app1+1,app2-1-app1));
        Pos_y := StrToInt(Copy(Testo1,app2+1,app3-1-app2));
        Nome := Copy(Testo1,app3+1,Length(Testo1)-app3);
//
        Img := TACTransparentImage.Create(Self);
//        Img.AutoSize := True;
        Img.Parent := self;
        Img.BitMap.LoadFromFile(Percorso+Nome);
        img.invalidate;
        Img.Transparent := True;
        Img.TransparentColor := Img.BitMap.Canvas.Pixels[0,0];
        Img.Left := pos_x;
        Img.Top := Pos_y;
        img.paint;
        Img.Visible := True;

        Add_Image(Img);
      End;

//********** Font Color
      if (Pos('FONTCOLOR',Testo2)=1) then
      begin
        FontColore := StrToInt(Copy(Testo1,Pos('=',Testo1)+1,Length(Testo1)-Pos('=',Testo1)+1));
      End;
//********** Font Bold
      if (Pos('FONTBOLD',Testo2)=1) then
      begin
        FontBold := (StrToInt(Copy(Testo1,Pos('=',Testo1)+1,Length(Testo1)-Pos('=',Testo1)+1))<>0);
      End;
//********** Font Italic
      if (Pos('FONTITALIC',Testo2)=1) then
      begin
        FontItalic := (StrToInt(Copy(Testo1,Pos('=',Testo1)+1,Length(Testo1)-Pos('=',Testo1)+1))<>0);
      End;
//********** Font Underline
      if (Pos('FONTUNDERLINE',Testo2)=1) then
      begin
        FontUnderline := (StrToInt(Copy(Testo1,Pos('=',Testo1)+1,Length(Testo1)-Pos('=',Testo1)+1))<>0);
      End;
//********** Font StrikeOut
      if (Pos('FONTSTRIKEOUT',Testo2)=1) then
      begin
        FontStrikeOut := (StrToInt(Copy(Testo1,Pos('=',Testo1)+1,Length(Testo1)-Pos('=',Testo1)+1))<>0);
      End;
//********** File
      if (Pos('FILE',Testo2)=1) then
      begin
        app1 := Pos('[',Testo2);
        app2 := Pos(',',Testo2);
        app3 := Pos('*',Testo2);
        app4 := Pos(']',Testo2);
        Pos_x := StrToInt(Copy(Testo1,app1+1,app2-1-app1));
        Pos_y := StrToInt(Copy(Testo1,app2+1,app3-1-app2));
        AppNome := Percorso+Copy(Testo1,app3+1,app4-1-app3);;
        //PageNumber := 1;
        insert_lbl(Pos_x,Pos_y,Pagina,Copy(Testo1,app4+1,Length(Testo1)-app4),AppNome);
      End;


      Conta1:=Conta1+1;

      Testo1 := ReadString('Page'+IntToStr(Num),'P'+IntToStr(Conta1),'');

    End;
  End;
End;


(******************************************************************************
 * Add_Label                                                                  *
 ******************************************************************************)
Procedure TACHyperLink.Add_Label(L:TLabel;Link:String);
Var   AppLbl1 : PACLabelList;
      AppLbl2 : PACLabelList;
Begin
  New(AppLbl1);
  AppLbl1^.Lbl := L;
  AppLbl1^.Link := Link;
  AppLbl1^.Next := Nil;
  if (ElencoLbl=Nil) then
  begin
    ElencoLbl := AppLbl1;
  end
  else
  begin
    AppLbl2 := ElencoLbl;
    While (AppLbl2^.Next<>Nil) Do AppLbl2 := AppLbl2^.Next;
    AppLbl2^.Next := AppLbl1;
  end;
End;
(******************************************************************************
 * Add_Image                                                                  *
 ******************************************************************************)
Procedure TACHyperLink.Add_Image(I:TACTransparentImage);
Var   AppImg1 : PACImageList;
      AppImg2 : PACImageList;
Begin
  New(AppImg1);
  AppImg1^.Img := I;
  AppImg1^.Next := Nil;
  if (ElencoImg=Nil) then
  begin
    ElencoImg := AppImg1;
  end
  else
  begin
    AppImg2 := ElencoImg;
    While (AppImg2^.Next<>Nil) Do AppImg2 := AppImg2^.Next;
    AppImg2^.Next := AppImg1;
  end;
End;

(******************************************************************************
 * Remove_Label                                                               *
 ******************************************************************************)
Procedure TACHyperLink.Remove_Label;
Var   AppLbl1 : PACLabelList;
      AppLbl2 : PACLabelList;
Begin
  AppLbl2 := ElencoLbl;
  While (AppLbl2<>Nil) Do
  Begin
    AppLbl1 := AppLbl2;
    AppLbl2 := AppLbl2^.Next;
    AppLbl1^.Lbl.Free;
    Dispose(AppLbl1);
  End;
  ElencoLbl:=Nil;
End;
(******************************************************************************
 * Remove_Image                                                               *
 ******************************************************************************)
Procedure TACHyperLink.Remove_Image;
Var   AppImg1 : PACImageList;
      AppImg2 : PACImageList;
Begin
  AppImg2 := ElencoImg;
  While (AppImg2<>Nil) Do
  Begin

    AppImg1 := AppImg2;
    AppImg2 := AppImg2^.Next;
    AppImg1^.Img.Visible := False;
    AppImg1^.Img.Free;
    Dispose(AppImg1);
  End;
  ElencoImg:=Nil;
End;


(******************************************************************************
 * on_Click                                                                   *
 ******************************************************************************)
Procedure TACHyperLink.on_Click(Sender: TObject);
Var
   AppLbl1 : PACLabelList;
   Nome    : String;
//   Main_Path : String;
Begin
  Nome := '';
  if (Sender.ClassType=TLabel) then
  begin
    if (TLabel(Sender).Tag>0) then
    begin
// cercale la label nell'elenco e vedere se  un link
      AppLbl1 := ElencoLbl;
      While (AppLbl1<>Nil) Do
      Begin
        if (AppLbl1^.Lbl=TLabel(Sender)) then Nome := AppLbl1^.Link;
        AppLbl1 := AppLbl1^.Next;
      End;
      if(Nome<>'') then
      begin
//        Main_Path:=ExtractFilePath(FileName);
//        if (Main_Path[Length(Main_Path)]<>'\') then Main_Path := Main_Path + '\';
//        FileName:=Main_Path+Nome;
        FileName:=Nome;
        PaginaDaCaricare:=1;
      end
      else PaginaDaCaricare:=TLabel(Sender).Tag;

      Invalidate;
    End;
  End;
End;

(******************************************************************************
 * Construtor                                                                 *
 ******************************************************************************)
Constructor TACHyperLink.Create(AOwner: TComponent);
Begin
  Inherited;
  PaginaDaCaricare := -1;
  ELencoLbl:=Nil;
  ElencoImg:=Nil;
//  Self.OnClick := on_Click;
End;
(******************************************************************************
 * Paint                                                                      *
 ******************************************************************************)
//procedure TACHyperLink.Paint(AOwner: TComponent);
procedure TACHyperLink.WMPaint(var Message: TWMPaint);
//procedure TACHyperLink.WM_Paint(Message:TMEssage); message WM_PAint;
Var Pg : Integer;
Begin
  Inherited;
  if (PaginaDaCaricare <> -1) then
  begin
    pg := PaginaDaCaricare;
    PaginaDaCaricare:=-1;
    Remove_Label;
    Remove_Image;
    PageNumber:=pg;

  end;
//  Self.OnClick := on_Click;
End;

(******************************************************************************
 * Destroy                                                                    *
 ******************************************************************************)
destructor TACHyperLink.Destroy;
Begin
 Remove_Label;
 Remove_Image;
 PageNumber := 0;
 Inherited;
End;
end.


