(******************************************************************************
 * TACRegistry                                                                *
 ******************************************************************************)
unit AcRegistry;

(******************************************************************************
 * interface                                                                  *
 ******************************************************************************)
 interface

(******************************************************************************
 * uses                                                                       *
 ******************************************************************************)
 uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  AcProcDeclare, DsgnIntf;

(******************************************************************************
 * type                                                                       *
 ******************************************************************************)
type
  TACRegSet=(HKEY_CLASSES_ROOT,
             HKEY_CURRENT_USER,
             HKEY_LOCAL_MACHINE,
             HKEY_USERS,
             HKEY_PERFORMANCE_DATA,
             HKEY_CURRENT_CONFIG,
             HKEY_DYN_DATA);
  TACRegistryString = class(TComponent)
  private
    { Private declarations }
    FRoot    : TACRegSet;        // Parametro
    FKeyName      : String;
    FValueName    : String;
    FStrValue     : String;
  protected
    { Protected declarations }
      WriteEnabled : Boolean;
//    procedure split(txt:string;var txt1,txt2,txt3,txt4,txt5:string);
      procedure setStrValue(txt:String);
      function  getStrValue:string;
      procedure setRoot(v1:TACRegSet);
      procedure setKey(txt:String);

  public
    { Public declarations }
      constructor Create(AOWner:TComponent);override;
  published
    { Published declarations }

    property Root : TACRegSet read FRoot Write SetRoot;
    property StrValue : String read getStrValue Write setStrValue;
    property KeyName : String read FKeyName Write setKey;
    property ValueName   : String read FValueName Write FValueName;
  end;


(******************************************************************************
 * TAccKeyEditProperty                                                        *
 ******************************************************************************)
type TAcKeyEditProperty = Class(TStringProperty)
 public
   function GetAttributes : TPropertyAttributes; override;
   procedure GetValues(Proc: TGetStrProc);override;
 end;

(******************************************************************************
 * TAccValueKeyEditProperty                                                   *
 ******************************************************************************)
type TAcValueEditProperty = Class(TAcKeyEditProperty)
 public
   procedure GetValues(Proc: TGetStrProc);override;
 end;


(******************************************************************************
 * implementation                                                             *
 ******************************************************************************)
implementation

(******************************************************************************
 * uses                                                                       *
 ******************************************************************************)
 uses Registry;

(******************************************************************************
 * setStrValue                                                                *
 ******************************************************************************)
procedure TACRegistryString.setStrValue(txt:String);
var  intRoot   : Integer;
     TReg      : TRegistry;
begin
 if (WriteEnabled=False) then exit;
 IntRoot := $80000000;
 if (Root = HKEY_CLASSES_ROOT)     then IntRoot := $80000000;
 if (Root = HKEY_CURRENT_USER)     then IntRoot := $80000001;
 if (Root = HKEY_LOCAL_MACHINE)    then IntRoot := $80000002;
 if (Root = HKEY_USERS)            then IntRoot := $80000003;
 if (Root = HKEY_PERFORMANCE_DATA) then IntRoot := $80000004;
 if (Root = HKEY_CURRENT_CONFIG)   then IntRoot := $80000005;
 if (Root = HKEY_DYN_DATA)         then IntRoot := $80000006;
 TReg := Nil;
 try
   TReg := TRegistry.create;
   TReg.RootKey := intRoot;
   if TReg.openkey(KeyName,True) then
   begin
     TReg.WriteString(ValueName,Txt);
   end;
 Finally
   if(TReg<>Nil) then TReg.free;
 end;
end;

(******************************************************************************
 * getStrValue                                                                *
 ******************************************************************************)
function TACRegistryString.getStrValue:string;
var  intRoot   : Integer;
     txt       : String;
     TReg      : TRegistry;
begin
 Txt:='';
 IntRoot := $80000000;
 if (Root = HKEY_CLASSES_ROOT)     then IntRoot := $80000000;
 if (Root = HKEY_CURRENT_USER)     then IntRoot := $80000001;
 if (Root = HKEY_LOCAL_MACHINE)    then IntRoot := $80000002;
 if (Root = HKEY_USERS)            then IntRoot := $80000003;
 if (Root = HKEY_PERFORMANCE_DATA) then IntRoot := $80000004;
 if (Root = HKEY_CURRENT_CONFIG)   then IntRoot := $80000005;
 if (Root = HKEY_DYN_DATA)         then IntRoot := $80000006;
 TReg := Nil;
 try
   TReg := TRegistry.create;
   TReg.RootKey := intRoot;
   if TReg.openkey(KeyName,False) then
   begin
     txt:=TReg.ReadString(ValueName);
   end;
 finally
   if(TReg<>Nil) then TReg.free;
 end;
 GetStrValue:=txt;
end;
(******************************************************************************
 * setRoot                                                                    *
 ******************************************************************************)
procedure TACRegistryString.setRoot(v1:TACRegSet);
Begin
 WriteEnabled:=False;
 FRoot:=v1;
 KeyName :='';
 ValueName :='';
 StrValue :='';
 WriteEnabled:=True;
End;

(******************************************************************************
 * setRoot                                                                    *
 ******************************************************************************)
procedure TACRegistryString.setKey(txt:String);
Begin
 WriteEnabled:=False;
 FKeyName := txt;
 ValueName :='';
 StrValue :='';
 WriteEnabled:=True;
End;

(******************************************************************************
 * GetAttributes                                                              *
 ******************************************************************************)
function TAcKeyEditProperty.GetAttributes : TPropertyAttributes;
begin
  Result:=inherited GetAttributes+[paValueList, paDialog, paMultiSelect];
end;

(******************************************************************************
 * GetValues                                                                  *
 ******************************************************************************)
//procedure TAcKeyEditProperty.Edit;
procedure TAcValueEditProperty.GetValues(Proc: TGetStrProc);
Var Root    : TACRegSet;
    IntRoot : Integer;
    List    : TStringList;
    TReg    : TRegistry;
    c1      : Integer;
    base    : String;
begin
  Root := (GetComponent(0) as TACRegistryString).Root;
  Base := (GetComponent(0) as TACRegistryString).KeyName;
  IntRoot := $80000000; // Valore di dafault
  if (Root = HKEY_CLASSES_ROOT)     then IntRoot := $80000000;
  if (Root = HKEY_CURRENT_USER)     then IntRoot := $80000001;
  if (Root = HKEY_LOCAL_MACHINE)    then IntRoot := $80000002;
  if (Root = HKEY_USERS)            then IntRoot := $80000003;
  if (Root = HKEY_PERFORMANCE_DATA) then IntRoot := $80000004;
  if (Root = HKEY_CURRENT_CONFIG)   then IntRoot := $80000005;
  if (Root = HKEY_DYN_DATA)         then IntRoot := $80000006;
  List := Nil;
  TReg := Nil;
  try
    list := TStringList.Create;
    TReg := TRegistry.create;
//    if (Root = HKEY_CLASSES_ROOT)     then IntRoot := $80000000;
//    if (Root = HKEY_CURRENT_USER)     then IntRoot := $80000001;
//    if (Root = HKEY_LOCAL_MACHINE)    then IntRoot := $80000002;
//    if (Root = HKEY_USERS)            then IntRoot := $80000003;
//    if (Root = HKEY_PERFORMANCE_DATA) then IntRoot := $80000004;
//    if (Root = HKEY_CURRENT_CONFIG)   then IntRoot := $80000005;
//    if (Root = HKEY_DYN_DATA)         then IntRoot := $80000006;
    TReg.RootKey:=IntRoot;
    TReg.openkey(Base,false);
    TReg.GetValueNames(List);
    for c1 := 0 to list.count-1 do
      proc(List.Strings[c1]);

  finally
    if(List<>Nil) then list.free;
    if(TReg<>Nil) then TReg.Free;
  end;
end;

(******************************************************************************
 * Create                                                                     *
 ******************************************************************************)
constructor TACRegistryString.Create(AOWner:TComponent);
Begin
  Inherited;
  WriteEnabled:=True;
End;

(******************************************************************************
 * Edit                                                                       *
 ******************************************************************************)
//procedure TAcKeyEditProperty.Edit;
procedure TAcKeyEditProperty.GetValues(Proc: TGetStrProc);
Var Root    : TACRegSet;
    IntRoot : Integer;
    List    : TStringList;
    TReg    : TRegistry;
    c1      : Integer;
    base    : String;
begin
  List := Nil;
  TReg := Nil;
  try
    list := TStringList.Create;
    TReg := TRegistry.create;
    Root := (GetComponent(0) as TACRegistryString).Root;
    Base := (GetComponent(0) as TACRegistryString).KeyName;
    IntRoot := $80000000; // Valore di dafault
    if (Root = HKEY_CLASSES_ROOT)     then IntRoot := $80000000;
    if (Root = HKEY_CURRENT_USER)     then IntRoot := $80000001;
    if (Root = HKEY_LOCAL_MACHINE)    then IntRoot := $80000002;
    if (Root = HKEY_USERS)            then IntRoot := $80000003;
    if (Root = HKEY_PERFORMANCE_DATA) then IntRoot := $80000004;
    if (Root = HKEY_CURRENT_CONFIG)   then IntRoot := $80000005;
    if (Root = HKEY_DYN_DATA)         then IntRoot := $80000006;
    TReg.RootKey:=IntRoot;
    TReg.openkey(Base,false);
    TReg.GetKeyNames(List);
    for c1 := 0 to list.count-1 do
      proc(Base+'\'+List.Strings[c1]);
  finally
    if(List<>Nil) then list.free;
    if(TReg<>Nil) then TReg.Free;
  end;
end;



end.
